import gc
gc.enable()
gc.set_debug(gc.DEBUG_UNCOLLECTABLE | gc.DEBUG_SAVEALL)


def os_memory_usage():
    """Memory usage of the current process in kilobytes."""
    status = None
    result = {'VmSize':0}
    try:
        # This will only work on systems with a /proc file system
        # (like Linux).
        status = open('/proc/self/status')
        for line in status:
            parts = line.split()
            key = parts[0][:-1]
            if key in result:
                print line,
                result[key] = int(parts[1])
    finally:
        if status is not None:
            status.close()
    return result

def runTest():
    import vcs
    import cdms2
    import sys
    import objgraph
    import time
    #from pympler import tracker
    #from pympler import muppy
    #from pympler import asizeof
    import random
    import collections

    f = cdms2.open(vcs.sample_data + "/clt.nc")
    data = f('clt')


    x = vcs.init(bg=1, geometry=(800, 600))
    x.setantialiasing(0)
    x.drawlogooff()


    #all_objects = muppy.get_objects()
    #print ("all_objects: %d"%len(all_objects))
    #all_objects = None
    os_memory_usage()
    print("# objects: %d"%len(gc.get_objects()))

    for i in range(500):
        #print("size=%d"%m['size'])
        if (i % 10 == 0):
            print ("\n%d: ======== Before plot ========"%i)
        #objgraph.show_growth(limit=3)
        #tr = tracker.SummaryTracker()

        x.plot(data,"default","boxfill")

        #objgraph.show_growth(limit=3)

        x.png("file_%i.png" % i)

        #print ("== Before clear %d =="%i)
        #objgraph.show_growth(limit=3)

        x.clear()
        time.sleep(1)

        if (i % 10 == 0):
            print ("After clear")
            #objgraph.show_growth()
            #tr.print_diff()
            #tr = None

            #all_objects = muppy.get_objects()
            #print ("all_objects: %d"%len(all_objects))
            #all_objects = None

            os_memory_usage()
            gc.collect()
            print("# objects: %d"%len(gc.get_objects()))

        #f1 = open("size%d.txt"%i, "w")
        #for object in dir(vcs):
        #    print >> f1, asizeof.asized(object, detail=1).format()
        #f1.close()

        #filename = "backref%d.png"%i
        #objgraph.show_chain(objgraph.find_backref_chain(random.choice(objgraph.by_type('')),
        #                                                objgraph.is_proper_module), filename=filename)
        #filename = None
        #from pudb import set_trace; set_trace()

runTest()

del runTest
del os_memory_usage

# gc.collect()

# leaks = {}

# for i,g in enumerate(gc.garbage):
#     t = type(g)
#     print "Leak %d: %s @0x%x:\n   %s"%(i, t, id(g), str(g)[:70])
#     leaks[t] = leaks.get(t, 0) + 1

# for t in leaks:
#     print "%7d: %s"%(leaks[t], t)

# print len(gc.garbage),"leaks total."
